package dtf.core;
import stamp.core.*;
import dtf.core.*;

public class Varactortable {

  static protected DAC dac;
  static protected I2C mem;
  static Int32 high = new Int32();
  static Int32 target = new Int32();
  static Int32 low = new Int32();
  static Int32 hi = new Int32();
  static Int32 lo = new Int32();
  static StringBuffer temp = new StringBuffer();

  public Varactortable(DAC dac, I2C mem)
  {
    this.mem = mem;
    this.dac = dac;
  }

  public static int recall(Int32 target)
  {
    int location = 0;
    int block = 0;
    int address = 0;
    while(true)
    {
      if (address == 252)
      {
        if (block == 6)
        {
          break;
        }
        address = 0;
        block ++;
      }
      high.set(mem.readstring(block, address, 6));
      if(target.equals(high))
      {
        address = address + 7;
        high.set(mem.readstring(block, address, 4));
        location = high.low;
        dac.update(location);
        break;
      }
      if(target.compare(high)<0)
      {
        address = address + 7;
        hi.set(mem.readstring(block, address, 4));
        address = address - 19;
        low.set(mem.readstring(block, address, 6));
        address = address + 7;
        lo.set(mem.readstring(block, address, 4));
        high.subtract(low);
        hi.subtract(lo);
        target.subtract(low);
        target.multiply(hi);
        target.divide(high);
        target.add(lo);
        location = target.low;
        System.out.println(location);
        dac.update(location);
        break;
      }
      address = address + 12;
    }
    return location;
  }
}