package dtf.core;
import stamp.core.*;
import dtf.core.*;

public class motor
{
  static statustable decode;
  static compiler decimal;
  static StringBuffer temp = new StringBuffer();
  public static final int ACK = 0x00;
  public static final int NAK = 0x01;
  final static int SERIAL_TX_PIN  = CPU.pin0;
  final static int SERIAL_RTS_PIN = CPU.pin1;
  final static int SERIAL_CTS_PIN = CPU.pin2;
  final static int SERIAL_RX_PIN  = CPU.pin3;
  static int hi = 0;
  static int lo = 0;
  int write = 0xA0;
  int read = 0xA1;
  final static int sync = 0x55;
  final static int stop = 0x00;
  final static int rev = 0x01;
  final static int setdc = 0x03;
  final static int getstatus = 0x05;
  final static int count = 0x06;
  final static int readcounter = 0x0B;
  final static int readfirm = 0x0E;
  final static int baud = 0x0C;
  static int counthi;
  static int countlo;
  static int location;
  static Uart toMMBE;
  static Uart fromMMBE;
  static resolver resolver = new resolver(CPU.pin2, CPU.pin3, CPU.pin4);
  static Int32 big = new Int32();
  final static Int32 zero = new Int32();
  static Int32 counts = new Int32();
  static int delta;


  public motor(Uart toMMBE, Uart fromMMBE)
  {
    this.toMMBE = toMMBE;
    this.fromMMBE = fromMMBE;
  }

  public static void reverse()
  {
    toMMBE.sendByte(sync);
    toMMBE.sendByte(rev);
  }

  public static void stop()
  {
    toMMBE.sendByte(sync);
    toMMBE.sendByte(stop);
  }
  
  public static void changebaud()
  {
    toMMBE.sendByte(sync);
    toMMBE.sendByte(baud);
  }

  public static void setdc(int speed)
  {
    toMMBE.sendByte(sync);
    toMMBE.sendByte(setdc);
    toMMBE.sendByte(speed);
    //System.out.println("Move");
  }

  public static int getstatus()
  {
    toMMBE.sendByte(sync);
    toMMBE.sendByte(getstatus);
    int status = (int)fromMMBE.receiveByte();
    int speed = (int)fromMMBE.receiveByte();
    return status;
  }

  public static int getspeed()
  {
    toMMBE.sendByte(sync);
    toMMBE.sendByte(getstatus);
    int status = (int)fromMMBE.receiveByte();
    int speed = (int)fromMMBE.receiveByte();
    return speed;
  }

  public static void oldresolver(int target)
  {
    while(true)
    {
      if (target > 4090)
      {
        System.out.println("Location error");
        target = 4090;
      }
      if (target < 10)
      {
        System.out.println("Location error");
        target = 10;
      }
      CPU.delay(100);
      location = resolver.read();
      if (location < target)
      {
        if(decode.motdir(getstatus()) == false)
        {
          reverse();
        }
      }
      if (location > target)
      {
        if (decode.motdir(getstatus()) == true)
        {
          reverse();
        }
      }
      if (location == target)
      {
        break;
      }
      counthi = 0;
      countlo = (Math.abs(target-location));
      countlo = countlo ;
      System.out.println(countlo);
      if (countlo == 0)
      {
        break;
      }
      while(true)
      {
        if (countlo > 255)
        {
          countlo = countlo - 255;
          counthi ++;
        }
        if (countlo <= 255)
        {
          break;
        }
      }
      count(counthi, countlo, 255);
      CPU.delay(500);
    }
  }

  public static void resolver(int target)
  {
    if (target > 4050)
    {
      System.out.println("Location error");
      target = 4050;
    }
    if (target < 40)
    {
      System.out.println("Location error");
      target = 40;
    }
    int speed = 255;
    if (resolver.read() < 2050)
    {
      if(decode.motdir(getstatus()) == false)
      {
        reverse();
      }
    }
    if (resolver.read() >= 2050)
    {
      if (decode.motdir(getstatus()) == true)
      {
        reverse();
      }
    }
    setdc(255);
    while(true)
    {
      delta = Math.abs(target - resolver.read());
      CPU.delay(10);
      if (delta < 500)
      {
        if (delta < 100)
        {
          stop();
          break;
        }
        if (speed > 128)
        {
          stop();
          speed = 128;
          setdc(speed);
        }
      }
      CPU.delay(10);
      if (delta < Math.abs(target - resolver.read()))
      {
        stop();
        reverse();
        setdc(speed);
      }
      CPU.delay(200);
    }
    while(true)
    {
      delta = Math.abs(target - resolver.read());
      speed = 93;
      setdc(speed);
      if (delta <= 4)
      {
        stop();
        if (Math.abs(target - resolver.read()) <= 2)
        {
          break;
        }
        setdc(speed);
      }
      if (delta < Math.abs(target - resolver.read()))
      {
        stop();
        reverse();
        setdc(speed);
      }
    }
    return;
  }

  public static int test(int target, int speed)
  {
    System.out.println("Test");
      if (Math.abs(target - resolver.read()) > 800)
      {
        if (Math.abs(target - resolver.read()) < 400)
        {
          if (Math.abs(target - resolver.read()) < 200)
          {
            if (speed > 75)
            {
              stop();
              System.out.println(resolver.read());
              speed = 75;
              CPU.delay(100);
              setdc(speed);
              return speed;
            }
          }
          if (speed > 128)
          {
            stop();
            System.out.println(resolver.read());
            speed = 90;
            CPU.delay(100);
            setdc(speed);
            return speed;
          }
        }
        if (speed < 255)
        {
          stop();
          System.out.println(resolver.read());
          speed = 255;
          System.out.println("Speed up");
          CPU.delay(100);
          setdc(speed);
          return speed;
        }
      }
      return speed;
  }

  public static void count(int counthi, int countlo)
  {
    big.set(counthi, countlo);
    if (big.compare(0)<0)
    {
      if(decode.motdir(getstatus()) == true)
      {
        reverse();
      }
    }
    if (big.compare(0)>0)
    {
      if(decode.motdir(getstatus()) == false)
      {
        reverse();
      }
    }
    while(true)
    {
      count(27,10,255);
      counts.set(readcounter());
      big.subtract(counts);
      if (big.compare(0) < 0)
      {
        break;
      }
    }
    compensation(big.high, big.low);
  }

  public static void count(int counthi, int countlo, int speed)
  {
    if (countlo<0)
    {
      countlo = countlo + 256;
    }
    if (counthi<0)
    {
      counthi = counthi + 256;
    }
    toMMBE.sendByte(sync);
    toMMBE.sendByte(count);
    toMMBE.sendByte(counthi);
    toMMBE.sendByte(countlo);
    toMMBE.sendByte(speed);
    int status = (int)fromMMBE.receiveByte();
    int speed2 = (int)fromMMBE.receiveByte();
  }

  public static StringBuffer readcounter()
  {
    toMMBE.sendByte(sync);
    toMMBE.sendByte(readcounter);
    int counthi = (int)fromMMBE.receiveByte();
    int countlo = (int)fromMMBE.receiveByte();
    if (countlo<0)
    {
      countlo = countlo + 256;
    }
    if (counthi<0)
    {
      counthi = counthi + 256;
    }
    return(decimal.hex(counthi,countlo));
  }

  public static int readfirm()
  {
    toMMBE.sendByte(sync);
    toMMBE.sendByte(readfirm);
    int firmware = (int)fromMMBE.receiveByte();
    return firmware;
  }

  public static void compensation(int high, int low)
  {
    big.set(high, low);
    int stop = -1;
    int temphi = 0;
    int templo = 0;
    while(true)
    {
      stop = -1;
      if (big.equals(zero)==true)
      {
        break;
      }
      if (big.compare(0)<0)
      {
        if(decode.motdir(getstatus()) == true)
        {
          reverse();
        }
      }
      if (big.compare(0)>0)
      {
        if(decode.motdir(getstatus()) == false)
        {
          reverse();
        }
      }
      CPU.delay(1000);
      counts.set(big);
      counts.abs();
      temphi = 0;
      templo = counts.low;
      while(true)
      {
        if (templo < 0)
        {
          templo = Math.abs(templo);
        }
        if (templo > 255)
        {
          templo = templo - 255;
          temphi ++;
        }
        else
        {
          break;
        }
      }
      templo = templo/2;
      if (templo == 0)
      {
        if (temphi == 0)
        {
          break;
        }
      }
      count(temphi, templo, 255);
      counts.set(readcounter());
      if (big.compare(0)>0)
      {
        if (stop <0)
        {
          big.subtract(counts);
          stop = 1;
        }
      }
      if (big.compare(0)<0)
      {
        if (stop <0)
        {
          big.add(counts);
          stop = 1;
        }
      }
    }
  }
}