package dtf.core;
import dtf.core.*;
import stamp.core.*;


public class hyperterminal
{
  protected static Uart toPC, fromPC;

  static StringBuffer temp = new StringBuffer();
  static char c;


  public hyperterminal(Uart toPC, Uart fromPC)
  {
    this.toPC = toPC;
    this.fromPC = fromPC;
  }

  public static void send(String data)
  {
    toPC.sendString(data);
    CPU.delay(1000);
  }

  public static void send(StringBuffer data)
  {
    toPC.sendBuffer(data);
    CPU.delay(1000);
  }

  public static void send(int num)
  {
    toPC.sendByte(num);
    CPU.delay(1000);
  }

  public static StringBuffer get()
  {
    bufferMessage();
    CPU.delay(1000);
    return temp;
  }

  public static void bufferMessage()
  {
    temp.clear();
    c = 0xff;
    while (c != '\r'){
      if(fromPC.byteAvailable()){
        c = (char)fromPC.receiveByte();
        if(c == '\b')
        {
          temp.delete(temp.length(), (temp.length()-1));
        }
        else
        {
          temp.append(c);
        }
      }
    }
  }

  public static void backspace()
  {
    send("\b");
  }

  public static void newline()
  {
    send("\n");
  }

  public static void cls()
  {
    send("\014");
  }

  public static void cr()
  {
    send("\r");
  }

  public static void tab()
  {
    send("\t");
  }

  public static void custom(int octal)
  {
    temp.clear();
    temp.append("\b");
    temp.delete(1,2);
    temp.append(octal);
    send(temp.toString());
  }

  public static void drop()
  {
    cr();
    newline();
    newline();
  }

  public static void enter()
  {
    cr();
    newline();
  }

}