package dtf.core;
import stamp.core.*;
import dtf.core.*;

public class resolver {

  protected int sdaPin, sclPin, scsPin;           // pins for resolver bus


  public resolver(int sdaPin, int sclPin, int scsPin)
  {
    this.sdaPin = sdaPin;
    this.sclPin = sclPin;
    this.scsPin = scsPin;
    CPU.writePin(sdaPin, true);                 // release bus pins to pull-ups
    CPU.writePin(sclPin, true);
    CPU.writePin(scsPin, true);
  }

  public int read()
  {
    int data = 0;
    do
    {
      CPU.writePin(scsPin, false);
      CPU.delay(30);
      CPU.writePin(sclPin, false);
      CPU.delay(300);
      data = CPU.shiftIn(sdaPin, sclPin, 12, CPU.PRE_CLOCK_MSB<<4);
      CPU.writePin(scsPin, true);
      CPU.writePin(sclPin, true);
      CPU.delay(1000);
    }while(data == 0);
    return data;
  }
}